#!/usr/bin/perl

### Random2ch.cgi
### Random2ch
### $Id: Random2ch.cgi,v 1.7.2.3 2002/11/08 00:45:07 okada Exp $
###
###
#use strict;
use Socket;
use DB_File;
use POSIX;
eval {require 'jcode.pl'}
or error('jcode.pl Ĥޤ');

# ϥåˤޤȤ᤿
my %option = (
			  httpPort     => 80,
			  nameSubback  => 'subback.html',
			  pathReadCgi  => 'test/read.cgi',
			  regexNeedUrl => qr{^http://(?:[^.]+\.)+(?:2ch\.net|bbspink\.com|machibbs\.com)/\S+/$}i,
			  #regexNeedUrl => qr{^http://(?:[^.]+\.)+(?:machibbs\.com)/\S+/$}i,
			  replaceWords => [qw(BoardName BoardUrl ThreadName ThreadUrl ThreadOrder ThreadCount)],
			  urlBbsmenu   => 'http://www.ff.iij4u.or.jp/~ch2/bbsmenu.html',
			  usedb        => 1, # DBǽȤʤ '1' Ȥʤʤ '0'
			  dbfile       => 'random2ch.db',
			  dblockfile   => 'dblock',
			  LOCK_EX      => 2,
			  LOCK_UN      => 8
);


#################################################################################
sub resultHtml {
	return \<<'EOF';
Content-type: text/html; charset=EUC-JP

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html lang="ja">

<head>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=EUC-JP">
<title>Randam2ch:Link</title>
</head>
<body>
<h1>Ƥȡ˥Ӥޤ</h1>
<hr>
	<p>
		<a href="__BoardUrl__">__BoardName__</a>Ĥ
		__ThreadOrder__: <a href="__ThreadUrl__">__ThreadName__</a>(__ThreadCount__)ؤäƤä㤤
	</p>
</body>
</html>
EOF
}

sub error {
	print <<EOF;
Content-type: text/html; charset=EUC-JP

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html lang="ja">
<head>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=EUC-JP">
<title>Randam2ch:error</title>
</head>
<body>
	<h1>顼</h1>
	<hr>
	<p>@_</p>
</body>
</html>
EOF

exit;
}
#################################################################################

# 

sub getLinks;
sub getHtml;

my %link =(
  		 ThreadName    =>'',
		 ThreadOrder   =>'',
		 ThreadCount   =>'',
		 ThreadUrl     =>'',
		 BordName      =>'',
		 BordUrl       =>''
);

# Ĥ
{
	my %board = %{ getLinks getHtml @option{'urlBbsmenu','httpPort'} };

	my $key = '';
	/$option{'regexNeedUrl'}/o or delete $board{$key}
		while ($key, $_) = each %board;

	my @key = keys %board;
	$link{'BoardName'} = $key[int(rand 1000) % $#key];
	$link{'BoardUrl'}  = $board{$link{'BoardName'}};
}

# 
{

		my $subback = $link{'BoardUrl'} . $option{'nameSubback'};
		my %thread  = %{ getLinks getHtml $subback, $option{'httpPort'} };

		my @key = keys %thread;
		# $link{'ThreadName'} = $key[int(rand 2000) % $#key];
		my $tempThreadName = $key[int(rand 2000) % $#key];

		my($server, $bbs) = ($link{'BoardUrl'} =~ m|^http://([^/]+)/([^/]+)/$|i);

	if ($link{'BoardUrl'} =~ m/(?:2ch|bbspink)/) {
		($link{ThreadOrder}, $link{ThreadName}, $link{ThreadCount})
			= ($tempThreadName =~ m/^(\d+):\s+(.*)\((\d+)\)$/);
		$link{'ThreadUrl'} = join '/', (
			   'http:/', $server, $option{'pathReadCgi'},
			   $bbs, $thread{$tempThreadName}
		);
	}elsif($link{'BoardUrl'} =~ m/(?:machibbs)/o) {
		($link{ThreadOrder}, $link{ThreadName}, $link{ThreadCount})
			= ($tempThreadName =~ m/^(.*)\((\d+)\)$/);
		$link{'ThreadUrl'} = join '/', (
			   'http:/', $server, $thread{$tempThreadName} =~ m|^\.\./(.*)|
		);
	}
}

# DBǽͭʾDBĤ
if ($option{usedb})
{
	our ($db, %h);
	open (DBLOCK, $option{dblockfile});
	flock DBLOCK, $option{LOCK_EX};
	
	$db = tie %h, "DB_File", $option{dbfile}
		or error("$option{dbfile}ޤ$!");

	############
	## DB ##
	############
	$h{time()} = join ',' , (
							 $link{ThreadUrl}, 
							 $link{ThreadName}, 
							 $link{ThreadOrder}, 
							 $link{ThreadCount}, 
							 $link{BoardName}, 
							 $link{BoardUrl}
							 );
	

	undef $db;
	untie %h;
	flock DBLOCK, $option{LOCK_UN};
}

# ̤
{
	my $result = ${ resultHtml() };
	$result =~ s/__${_}__/$link{$_}/g for @{ $option{'replaceWords'} };
	print $result;	
}



sub getHtml {
	my($host, $path, $port) = (shift =~ m|^http://([^/]+)(/.*)|, shift);

	my $iaddr = inet_aton($host)
		or error("$host can't be found.");
	socket(SOCKET, PF_INET, SOCK_STREAM, 0)
		or error("Can't generate socket.");
	connect(SOCKET, pack_sockaddr_in($port, $iaddr))
		or error("Can't connect port:$port at $host.");
	
	my $refContent = '';
	select SOCKET;
	{
		my $n = "\x0d\x0a";
		local $| = 1;
		print(
			'GET ', $path, ' HTTP/1.0', $n,
			'HOST: ', $host, ':', $port, $n,
			$n,
	    );
		
		'skip' until <SOCKET> =~ /^$n$/o;
		
		local $/ = undef;
		$refContent = \<SOCKET>
	}
	select STDOUT;

	return $refContent;
}

sub getLinks {
	my $html = ${ $_[0] };

	jcode::convert(\$html, 'euc');

	my($content, %links) = ();
	while ($html =~ m|<[Aa]([^>]+)>(.*?)</[Aa]>|gs) {
		$content = $2;
		$1 =~ m#[Hh][Rr][Ee][Ff]=([-./0-9:A-Za-z_]+|"[^"]+"|'[^']+')#s or next; #"''
		($_ = $1) =~ s/^(["'])// and s/$1$//;	#'"]] ȤƤн
		
	   $links{$content} = $_;
	}

	return \%links;
}
