#!/usr/bin/perl

### showlog.cgi for Random2ch
### Random2chɽ
### $Id: showlog.cgi,v 1.1.2.1 2002/11/08 00:46:20 okada Exp $
###
use POSIX;
use DB_File;
my %option = (
			  dbfile       => 'random2ch.db',
			  dblockfile   => 'dblock',
			  LOCK_EX      => 2,
			  LOCK_UN      => 8
);
#############################################################################
sub error {
	print <<EOF;
Content-type: text/html; charset=EUC-JP

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html lang="ja">
<head>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=EUC-JP">
<title>Randam2ch:error</title>
</head>
<body>
	<h1>顼</h1>
	<hr>
	<p>@_</p>
</body>
</html>
EOF

exit;
}
#############################################################################
#
# 
%data = (
		 ThreadName    =>'',
		 ThreadOrder   =>'',
		 ThreadCount   =>'',
		 ThreadUrl     =>'',
		 BordName      =>'',
		 BordUrl       =>'',
		 TimeStamp     =>'',
);

# DBǡɤ߹
$db = tie %h, "DB_File", $option{dbfile}
or error("$option{dbfile}ޤ$!");

# HTML table 
{
	
	our $table = <<EOF;
<table border=1>
<tr>
<td></td>
<td>̾</td>
<td>URL</td>
<td>ֹ</td>
<td>쥹</td>
<td>̾</td>
<td>URL</td>
</tr>
EOF
	while (($k, $v) = each %h){
		$data{TimeStamp} = $k;
		
		($data{ThreadUrl}, 
		 $data{ThreadName}, 
		 $data{ThreadOrder}, 
		 $data{ThreadCount}, 
		 $data{BoardName}, 
		 $data{BoardUrl}) = (split /,/ ,$v);
		
		$time = strftime("%y/%m/%d (%a) %H:%M:%S", localtime($data{TimeStamp}));
		$table .= <<EOF;
<tr>
<td>$time</td>
<td><a href="$data{ThreadUrl}">$data{ThreadName}</a></td>
<td><a href="$data{ThreadUrl}">$data{ThreadUrl}</a></td>
<td>$data{ThreadOrder}</td>
<td>$data{ThreadCount}</td>
<td><a href="$data{BoardUrl}">$data{BoardName}</a></td>
<td><a href="$data{BoardUrl}">$data{BoardUrl}</a></td>
</tr>
EOF

	}
	$table .= '</table>';
}

### ̤
print <<EOF;
Content-type: text/html; charset=EUC-JP

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html lang="ja">

<head>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=EUC-JP">
<title>Randam2ch:</title>
</head>
<body>
<h1>2ch</h1>
<hr>
$table
</body>
</html>
EOF

